package com.tanpu.community.manager;

import com.tanpu.community.api.constants.CollectionTypeEnum;
import com.tanpu.community.api.constants.CommentTypeEnum;
import com.tanpu.community.dao.entity.community.CollectionEntity;
import com.tanpu.community.dao.entity.community.CommentEntity;
import com.tanpu.community.dao.entity.community.FansRelEntity;
import com.tanpu.community.dao.entity.community.ThemeEntity;
import com.tanpu.community.service.CollectionService;
import com.tanpu.community.service.CommentService;
import com.tanpu.community.service.FansRelService;
import com.tanpu.community.service.ThemeService;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.tomcat.jni.Local;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class ThemeManager {
    @Resource
    private ThemeService themeService;

    @Autowired
    private CollectionService collectionService;

    @Autowired
    private CommentService commentService;

    @Autowired
    private FansRelService fansRelService;

    public List<ThemeEntity> selectHotThemes(){
        //TOTO:根据算法计算推荐主题
        return null;
    }


    public List<ThemeEntity> selectInterestThemes(String userId){
        List<String> fansRelEntities = fansRelService.queryFansByFollowerId(userId).stream().map(FansRelEntity::getIdolId).collect(Collectors.toList());

        return null;
    }

    //点赞
    public void like(String themeId, String userId) {
        CollectionEntity collectionEntity = new CollectionEntity();
        collectionEntity.setCollectionType(CollectionTypeEnum.LIKE.getCode());
        collectionEntity.setAuthorId(userId);
        collectionEntity.setTargetId(themeId);
        collectionEntity.setCreateBy(userId);
        collectionEntity.setCreateTime(LocalDateTime.now());
        collectionService.insertCollection(collectionEntity);
    }

    //评论
    public void comment(String themeId, String userId,String comment) {
        CommentEntity commentEntity = new CommentEntity();
        commentEntity.setTargetId(themeId);
        commentEntity.setAuthorId(userId);
        commentEntity.setCommentType(CommentTypeEnum.TEXT.getCode());
        commentEntity.setContent(comment);
        commentService.insertComment(commentEntity);
    }

    //转发
    public void forward(String themeId, String user) {

    }

    //分享
    public void share(String themeId, String user) {

    }

    //收藏
    public void book(String themeId, String userId) {
        CollectionEntity collectionEntity = new CollectionEntity();
        collectionEntity.setCollectionType(CollectionTypeEnum.BOOK.getCode());
        collectionEntity.setAuthorId(userId);
        collectionEntity.setTargetId(themeId);
        collectionEntity.setCreateBy(userId);
        collectionEntity.setCreateTime(LocalDateTime.now());
        collectionService.insertCollection(collectionEntity);
    }
    //投诉
    public void complaint(String themeId, String user) {

    }
    //屏蔽
    public void conceal(String themeId, String user) {

    }
}
